﻿using Syncfusion.Windows.Diagram;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            createNodes();
        }
        public void createNodes()
        {
            //Defines the nodes and adds them to the model.
            Node Node1 = addNode("Node1", 205, 100, Shapes.FlowChart_Decision, "Node1", "FlowChart_Decision",100,100);
            Node Node2 = addNode("Node2", 435, 100, Shapes.RoundedSquare, "Node2", "RoundedSquare",200,100);                                    
            Connect(Node1, Node2, DecoratorShape.Circle, DecoratorShape.Circle);            

        }
        private Node addNode(String name, double offsetx, double offsety, Shapes shape, String label, String tooltip, double width, double height)
        {
            Node node = new Node(Guid.NewGuid(), name);
            node.OffsetX = offsetx;
            node.OffsetY = offsety;
            node.Tag = "IsFirstLoaded";
            node.Shape = shape;
            node.Label = label;
            node.ToolTip = tooltip;
            node.Width = width;
            node.Height = height;
            node.IsLabelDragable = true;
            model.Nodes.Add(node);
            return node;
        }
        private void Connect(Node headnode, Node tailnode, DecoratorShape headdecorator, DecoratorShape taildecorator)
        {
            LineConnector conn = new LineConnector();
            conn.ConnectionEndSpace = 6;
            conn.HeadNode = headnode;
            conn.TailNode = tailnode;
            conn.HeadDecoratorShape = headdecorator;
            conn.TailDecoratorShape = taildecorator;
            conn.ConnectorType = ConnectorType.Straight;
            conn.LabelWidth = 200;
            //conn.CustomLabelPosition = CustomLabelPositions.Drag;
            //conn.LabelPosition = new Point(50, 50);
            conn.EnableMultilineLabel = true;
            conn.LabelTextWrapping = TextWrapping.Wrap;
            model.Connections.Add(conn);
        }
    }

}
